/*!
 * @nuxt/cli v2.8.1 (c) 2016-2019

 * - All the amazing contributors
 * Released under the MIT License.
 * Website: https://nuxtjs.org
*/
'use strict';

require('path');
require('consola');
require('exit');
require('@nuxt/utils');
require('chalk');
require('std-env');
require('wrap-ansi');
require('boxen');
require('./cli-chunk2.js');
require('@nuxt/config');
const __chunk_3 = require('./cli-chunk3.js');
require('pretty-bytes');
const __chunk_4 = require('./cli-chunk4.js');

const start = {
  name: 'start',
  description: 'Start the application in production mode (the application should be compiled with `nuxt build` first)',
  usage: 'start <dir>',
  options: {
    ...__chunk_3.common,
    ...__chunk_3.server
  },
  async run(cmd) {
    const config = await cmd.getNuxtConfig({ dev: false, _start: true });
    const nuxt = await cmd.getNuxt(config);

    // Listen and show ready banner
    await nuxt.server.listen();
    __chunk_4.showBanner(nuxt);
  }
};

exports.default = start;
